unit umain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ComCtrls,

  fphttpclient, OpenSSLSockets, OpenSSL,

  fileinfo, winpeimagereader, elfreader, machoreader;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Memo1: TMemo;
    StatusBar1: TStatusBar;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    function GetSSLVersion: string;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  http: TFPHTTPCLIENT;
  Response: TMemoryStream;
begin
  Memo1.Clear;
  InitSSLInterface; // <- !
  http := TFPHTTPCLIENT.Create(nil);
  Response := TMemoryStream.Create;
  try
    try
      http.Get(Edit1.Text, Response);
      Response.Seek(0, soFromBeginning);
      Memo1.Lines.LoadFromStream(Response);

      StatusBar1.Panels[0].Text := http.ResponseStatusText;  // ResponseStatusText
      StatusBar1.Panels[1].Text := http.ResponseStatusCode.ToString;  // ResponseStatusCode
    except
      Memo1.Lines.LoadFromStream(Response);

      StatusBar1.Panels[0].Text := http.ResponseStatusText;  // ResponseStatusText
      StatusBar1.Panels[1].Text := http.ResponseStatusCode.ToString;  // ResponseStatusCode
    end;
  finally
    http.Free;
    Response.Free;
  end;

  // dll version
  StatusBar1.Panels[2].Text := GetSSLVersion;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Memo1.Clear;
end;

function TForm1.GetSSLVersion: string;
var
  FileVerInfo: TFileVersionInfo;
begin
  Result := '';
  FileVerInfo := TFileVersionInfo.Create(nil);
  try
    {$ifdef windows}
      FileVerInfo.FileName := 'ssleay32.dll';
    {$endif}
    {$ifdef linux}
      FileVerInfo.FileName := '/usr/lib/ssl/libssl.so';  // Welcher Pfad ?
    {$endif}

    FileVerInfo.ReadFileInfo;
    Result := FileVerInfo.VersionStrings.Values['ProductVersion'];
  finally
    FileVerInfo.Free;
  end;

end;

end.

